require_relative 'Agam11_split2'
require_relative 'Agam16_symbol'
require_relative 'Agam21_mix'

module GamalielPelino
    class Player
        include Playable
        
        attr_accessor :name, :health
        def initialize(name, health=100)
            @name = name.capitalize
            @health = health
            @found_pieces = Hash.new(0)
        end

        def name
            "#{@name}"
        end

        def found_piece(itemss)
            @found_pieces[itemss.item] += itemss.points
            puts "#{@name}'s treasures: #{@found_pieces}"
        end


        def each_found_piece
            @found_pieces.each do |item, points|
            yield Piece.new(item, points)
            end
        end

        def points
            @found_pieces.values.reduce(0, :+)
        end
        
        def health
            "#{@health}"
        end

        def score 
            halt = @health 
            halt += @name.length
        end

        def self.from_csv(string)
            name, health = string.split(',')
            Player.new(name, Integer(health))
        end
        
        def to_csv
        "#{@name},#{@health}"
        end

        def to_s
            "I'm #{@name} with a health of #{@health} and my score is #{score}"
        end
    end
end