require_relative 'Agam11_split1'
require_relative 'agam14_module'
require_relative 'Agam16_symbol'

require_relative 'Agam21_audit'

module GamalielPelino
    class Die
    include Auditable
            attr_reader :number

            def initialize
                roll
            end

            def roll
                @number = rand(1..6)
                audit
                @number
            end
    end
end

 module GamalielPelino 
    class Game

        def initialize(playlist)
            @playlist = playlist
            @players = []
        end

        def add_player(player)
            @players << player
        end

        def play(rounds)
            puts "There are #{@players.size} players in #{@playlist}:"
            
            @players.each do |player|
                puts player
            end
            1.upto(rounds) do |count|
                puts "\n rounds #{count}"
                @players.each do |player|
                    GameTurn.take_turn(player)   
                    puts player
                end
                
            end    
        end

        def load_players(default_player_file)
            File.readlines(default_player_file).each do |line|
                add_player(Player.from_csv(line))
            end
        end

        # def save_high_scores(to_file="Agam19_save.csv")
        #     File.open(to_file, "w") do |file|
        #       file.puts "#{@title} High Scores:"
        #       @players.sort.each do |player|
        #             file.puts player.to_csv
        #       end
        #     end
        # end


        def print_stats
            strong_players, wimpy_players = @players.partition { |player| player.strong? }

            puts "\n#{@title} Statistics:"

            puts "#{strong_players.size} strong players:"
            
            strong_players.each do |player|
            puts "#{player.name} (#{player.health})"
            end
        
            puts "\n#{wimpy_players.size} wimpy players:"

            wimpy_players.each do |player|
            puts "#{player.name} (#{player.health})"
            end
            
            sorted_players = @players.sort { |a, b| b.score <=> a.score }

            puts "\n#{@title} High Scores:"

            sorted_players.each do |player|
                formatted_name = player.name.ljust(20, '.')
                puts "#{formatted_name} #{player.score}"
            end

            # puts "\n#{@title} High Scores:"
            # @players.sort.each do |player|
            #     puts high_score_entry(player)
            # end
    end
        
        def title
            "==#{@playlist}=="
        end

        def call_items
            items = Item::PIECE
            puts "\n There are #{items.size} treasure to be found:"
            
            items.each do |call|
                puts "A #{call.item} is worth #{call.points} points"
            end

        end
    end
end
